from spring_util import *

def elastic_data():

    # Simulation model
    Mx1 = 4
    My1 = 8
    h = 0.8
    (x, v, m, radius, c) = generate_masses(Mx1, My1, h)

    Mx2 = 3
    My2 = 4
    h = 0.8
    (x2, v2, m2, radius2, c2) = generate_masses(Mx2, My2, h)
    
    x2[:] += array([-0.5, 7.0])

    offset = size(x, 0)
    for ci in c2:
        ci[0] += offset
        ci[1] += offset

    x = append(x, x2, axis=0)
    v = append(v, v2, axis=0)
    m = append(m, m2, axis=0)
    radius = append(radius, radius2, axis=0)
    c = append(c, c2, axis=0)

    C = len(c)
    
    M1 = Mx1*My1 + Mx2*My2
    
    # Set initial values
    x[:] += array([-4.0, -6.0])
    
    v[:, 0] = 0.0
    v[:, 1] = 0.0
    #v[0:M1/2, 0] = 6.0 * 0.0
    #v[M1/2:-1, 0] = -6.0 * 0.0

    x = append(x, [[0, -9 - 10000.0]], axis=0)
    v = append(v, [[0, 0]], axis=0)
    m = append(m, [1.0e6], axis=0)
    radius = append(radius, [10000.0], axis=0)

    x = append(x, [[-9 - 10000.0, 0.0]], axis=0)
    v = append(v, [[0, 0]], axis=0)
    m = append(m, [1.0e6], axis=0)
    radius = append(radius, [10000.0], axis=0)

    x = append(x, [[9 + 10000.0, 0.0]], axis=0)
    v = append(v, [[0, 0]], axis=0)
    m = append(m, [1.0e6], axis=0)
    radius = append(radius, [10000.0], axis=0)

    M = M1 + 3

    cmat = zeros([M, M], dtype=bool)
    L = zeros([M, M], 'd')
    for ci in c:
        cmat[ci[0], ci[1]] = True
        r = norm(x[ci[0], :] - x[ci[1], :])
        L[ci[0], ci[1]] = r

    # "Boundary conditions", penalty Dirichlet BCs
    g = zeros((M, 2), 'd')
    g[:-3] += array([0.0, -10.0])

    E = 1000.0
    #L = 0.7
    B = 40.0
    dt = 0.2 * min(h / sqrt(E), h / B)
    method = "Euler"
    contact = True
    
    return (x, v, c, cmat, m, g, E, L, B, M, C, dt, radius, contact, method)
