import os, sys, math, time
from math import *
from numpy import *
from pylab import *

def gauss(x):
  a = 4
  b = -5
  c = 1
  return a*exp(-pow(x-b, 2.0)/(2.0*c))

def generate_masses(Mx, My, h):
  x = zeros([Mx*My, 2], 'd')
  v = zeros([Mx*My, 2], 'd')
  m = zeros([Mx*My], 'd')
  radius = zeros([Mx*My], 'd')
  m[:] = 1.0
  radius[:] = h / 1.6
  clist = []
  for i in range(0, Mx):
    for j in range(0, My):
      id = i + j * Mx

      # Set coordinate of mass
      x[id] = array([i*h, j*h])

      # Create springs for mass
      for ii in [-1, 0, 1]:
        for jj in [-1, 0, 1]:
          if (i + ii) >= 0 and (i + ii) < Mx and \
                (j + jj) >= 0 and (j + jj) < My and \
                (i + j * Mx != (i + ii + (j + jj) * Mx)):
              clist.append([i + j * Mx, i + ii + (j + jj) * Mx])
    
  c = array(clist)
  return (x, v, m, radius, c)

def spring_plot(tarr, xarr, varr, farr, counter):
    # Plot constructed functions
    subplot(311)
    plot(tarr[:counter], farr[:counter])
    xlabel('t')
    ylabel('f')
    subplot(312)
    plot(tarr[:counter], varr[:counter])
    xlabel('t')
    ylabel('v')
    subplot(313)
    plot(tarr[:counter], xarr[:counter])
    xlabel('t')
    ylabel('x')
    show()
    os._exit(0)
