from spring_util import *

def wave_data():

    # Simulation model
    Mx = 40*2
    My = 1

    h = 16.0/float(Mx)
    (x, v, m, radius, c) = generate_masses(Mx, My, h)

    m[:] = 5.0*h
    
    C = len(c)
    
    M = Mx*My
    
    # Set initial values
    x[:] -= array([8.0, 0.0])
    
    v[:, 0] = 0.0
    for i in range(1, Mx):
        x[i] += array([0.0, gauss(x[i, 0])])
        
    cmat = zeros([M, M], dtype=bool)
    L = zeros([M, M], 'd')
    for ci in c:
        #cmat[ci[0], ci[1]] = True
        #r = norm(x[ci[0], :] - x[ci[1], :])
        L[ci[0], ci[1]] = 0.0

    # "Boundary conditions", penalty Dirichlet BCs
    g = zeros((M, 2), 'd')
    g += array([0.0, 0.0])

    g[0] = array([0.0, 0.0])
    m[0] = 1.0e9
    v[0] = array([0.0, 0.0])

    g[Mx-1] = array([0.0, 0.0])
    m[Mx-1] = 1.0e9
    v[Mx-1] = array([0.0, 0.0])

    #E = 400.0
    E = 80.0/h
    #B = 0.0002
    B = 4.0e-5/h
    dt = 0.5 * min(h / sqrt(E), h / B)
    print "dt: ", dt
    method = "Midpoint"
    contact = False

    return (x, v, c, cmat, m, g, E, L, B, M, C, dt, radius, contact, method)
